<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="_g_u_i___x_8c" kind="file" language="C++">
    <compoundname>GUI_X.c</compoundname>
    <includes local="yes" refid="emwin_8h">emwin.h</includes>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/*********************************************************************</highlight></codeline>
<codeline lineno="2"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />SEGGER<sp />Microcontroller<sp />GmbH<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="3"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Solutions<sp />for<sp />real<sp />time<sp />microcontroller<sp />applications<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="4"><highlight class="comment">**********************************************************************</highlight></codeline>
<codeline lineno="5"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="6"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(c)<sp />1996<sp />-<sp />2018<sp /><sp />SEGGER<sp />Microcontroller<sp />GmbH<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="7"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="8"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Internet:<sp />www.segger.com<sp /><sp /><sp /><sp />Support:<sp /><sp />support@segger.com<sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="9"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="10"><highlight class="comment">**********************************************************************</highlight></codeline>
<codeline lineno="11"><highlight class="comment" /></codeline>
<codeline lineno="12"><highlight class="comment">**<sp />emWin<sp />V5.48<sp />-<sp />Graphical<sp />user<sp />interface<sp />for<sp />embedded<sp />applications<sp />**</highlight></codeline>
<codeline lineno="13"><highlight class="comment">All<sp /><sp />Intellectual<sp />Property<sp />rights<sp /><sp />in<sp />the<sp />Software<sp />belongs<sp />to<sp /><sp />SEGGER.</highlight></codeline>
<codeline lineno="14"><highlight class="comment">emWin<sp />is<sp />protected<sp />by<sp /><sp />international<sp />copyright<sp />laws.<sp /><sp />Knowledge<sp />of<sp />the</highlight></codeline>
<codeline lineno="15"><highlight class="comment">source<sp />code<sp />may<sp />not<sp />be<sp />used<sp />to<sp />write<sp />a<sp />similar<sp />product.<sp /><sp />This<sp />file<sp />may</highlight></codeline>
<codeline lineno="16"><highlight class="comment">only<sp />be<sp />used<sp />in<sp />accordance<sp />with<sp />the<sp />following<sp />terms:</highlight></codeline>
<codeline lineno="17"><highlight class="comment" /></codeline>
<codeline lineno="18"><highlight class="comment">The<sp />software<sp /><sp />has<sp />been<sp />licensed<sp />to<sp /><sp />Cypress<sp />Semiconductor<sp />Corporation,</highlight></codeline>
<codeline lineno="19"><highlight class="comment">whose<sp />registered<sp /><sp />office<sp />is<sp />situated<sp /><sp />at<sp />198<sp />Champion<sp />Ct.<sp />San<sp />Jose,<sp />CA</highlight></codeline>
<codeline lineno="20"><highlight class="comment">95134<sp />USA<sp /><sp />solely<sp />for<sp />the<sp /><sp />purposes<sp />of<sp />creating<sp /><sp />libraries<sp />for<sp />Cypress</highlight></codeline>
<codeline lineno="21"><highlight class="comment">PSoC3<sp />and<sp /><sp />PSoC5<sp />processor-based<sp />devices,<sp /><sp />sublicensed<sp />and<sp />distributed</highlight></codeline>
<codeline lineno="22"><highlight class="comment">under<sp /><sp />the<sp /><sp />terms<sp /><sp />and<sp /><sp />conditions<sp /><sp />of<sp /><sp />the<sp /><sp />Cypress<sp /><sp />End<sp />User<sp />License</highlight></codeline>
<codeline lineno="23"><highlight class="comment">Agreement.</highlight></codeline>
<codeline lineno="24"><highlight class="comment">Full<sp />source<sp />code<sp />is<sp />available<sp />at:<sp />www.segger.com</highlight></codeline>
<codeline lineno="25"><highlight class="comment" /></codeline>
<codeline lineno="26"><highlight class="comment">We<sp />appreciate<sp />your<sp />understanding<sp />and<sp />fairness.</highlight></codeline>
<codeline lineno="27"><highlight class="comment">----------------------------------------------------------------------</highlight></codeline>
<codeline lineno="28"><highlight class="comment">Licensing<sp />information</highlight></codeline>
<codeline lineno="29"><highlight class="comment">Licensor:<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />SEGGER<sp />Microcontroller<sp />Systems<sp />LLC</highlight></codeline>
<codeline lineno="30"><highlight class="comment">Licensed<sp />to:<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cypress<sp />Semiconductor<sp />Corp,<sp />198<sp />Champion<sp />Ct.,<sp />San<sp />Jose,<sp />CA<sp />95134,<sp />USA</highlight></codeline>
<codeline lineno="31"><highlight class="comment">Licensed<sp />SEGGER<sp />software:<sp />emWin</highlight></codeline>
<codeline lineno="32"><highlight class="comment">License<sp />number:<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI-00319</highlight></codeline>
<codeline lineno="33"><highlight class="comment">License<sp />model:<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Services<sp />and<sp />License<sp />Agreement,<sp />signed<sp />June<sp />10th,<sp />2009</highlight></codeline>
<codeline lineno="34"><highlight class="comment">Licensed<sp />platform:<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Any<sp />Cypress<sp />platform<sp />(Initial<sp />targets<sp />are:<sp />PSoC3,<sp />PSoC5)</highlight></codeline>
<codeline lineno="35"><highlight class="comment">----------------------------------------------------------------------</highlight></codeline>
<codeline lineno="36"><highlight class="comment">Support<sp />and<sp />Update<sp />Agreement<sp />(SUA)</highlight></codeline>
<codeline lineno="37"><highlight class="comment">SUA<sp />period:<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />2009-06-12<sp />-<sp />2022-07-27</highlight></codeline>
<codeline lineno="38"><highlight class="comment">Contact<sp />to<sp />extend<sp />SUA:<sp /><sp /><sp /><sp />sales@segger.com</highlight></codeline>
<codeline lineno="39"><highlight class="comment">----------------------------------------------------------------------</highlight></codeline>
<codeline lineno="40"><highlight class="comment">File<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />GUI_X.C</highlight></codeline>
<codeline lineno="41"><highlight class="comment">Purpose<sp /><sp /><sp /><sp /><sp />:<sp />Config<sp />/<sp />System<sp />dependent<sp />externals<sp />for<sp />GUI</highlight></codeline>
<codeline lineno="42"><highlight class="comment">---------------------------END-OF-HEADER------------------------------</highlight></codeline>
<codeline lineno="43"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"emwin.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="46"><highlight class="normal" /></codeline>
<codeline lineno="47"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />EMWIN_ENABLED</highlight><highlight class="normal" /></codeline>
<codeline lineno="48"><highlight class="normal" /></codeline>
<codeline lineno="49"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="50"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"GUI.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="51"><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(GUI_OS<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline lineno="53"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#include<sp />"cyabs_rtos.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="54"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /></codeline>
<codeline lineno="56"><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal">{</highlight></codeline>
<codeline lineno="60"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(GUI_OS<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp />cy_mutex_t<sp />emwin_mutex;</highlight></codeline>
<codeline lineno="65"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="66"><highlight class="normal" /></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />emWin<sp />timer<sp />clock<sp />value<sp />in<sp />Hz<sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />EMWIN_TIMER_CLOCK_HZ<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(100000u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />emWin<sp />timer<sp />period<sp />value<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />EMWIN_TIMER_PERIOD<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(99u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />emWin<sp />timer<sp />interrupt<sp />priority<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />EMWIN_TIMER_IRQ_PRIORITY<sp /><sp /><sp /><sp /><sp /><sp />(7u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal"><sp /><sp /><sp /><sp />cyhal_timer_t<sp />emwin_timer;</highlight></codeline>
<codeline lineno="77"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">volatile</highlight><highlight class="normal"><sp />GUI_TIMER_TIME<sp />emwin_time_ms;</highlight></codeline>
<codeline lineno="78"><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />emwin_timer_init(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="80"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />isr_emwin_timer(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg,<sp />cyhal_timer_event_t<sp />event);</highlight></codeline>
<codeline lineno="81"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />emwin_timer_syspm_callback(cyhal_syspm_callback_state_t<sp />state,<sp />cyhal_syspm_callback_mode_t<sp />mode,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />callback_arg);</highlight></codeline>
<codeline lineno="82"><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp />cyhal_syspm_callback_data_t<sp />emwin_timer_syspm_callback_data<sp />=</highlight></codeline>
<codeline lineno="84"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.callback<sp />=<sp />&amp;emwin_timer_syspm_callback,</highlight></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.states<sp />=<sp />(cyhal_syspm_callback_state_t)(CYHAL_SYSPM_CB_CPU_DEEPSLEEP<sp />|<sp />CYHAL_SYSPM_CB_SYSTEM_HIBERNATE),</highlight></codeline>
<codeline lineno="87"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.next<sp />=<sp />NULL,</highlight></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.args<sp />=<sp />NULL,</highlight></codeline>
<codeline lineno="89"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.ignore_modes<sp />=<sp />0,</highlight></codeline>
<codeline lineno="90"><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="91"><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="93"><highlight class="normal" /></codeline>
<codeline lineno="94"><highlight class="normal" /><highlight class="comment">/*********************************************************************</highlight></codeline>
<codeline lineno="95"><highlight class="comment">*</highlight></codeline>
<codeline lineno="96"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp />Timing:</highlight></codeline>
<codeline lineno="97"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI_X_GetTime()</highlight></codeline>
<codeline lineno="98"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI_X_Delay(int)</highlight></codeline>
<codeline lineno="99"><highlight class="comment">*</highlight></codeline>
<codeline lineno="100"><highlight class="comment">*<sp /><sp /><sp />Some<sp />timing<sp />dependent<sp />routines<sp />require<sp />a<sp />GetTime</highlight></codeline>
<codeline lineno="101"><highlight class="comment">*<sp /><sp /><sp />and<sp />delay<sp />function.<sp />Default<sp />time<sp />unit<sp />(tick),<sp />normally<sp />is</highlight></codeline>
<codeline lineno="102"><highlight class="comment">*<sp /><sp /><sp />1<sp />ms.</highlight></codeline>
<codeline lineno="103"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="104"><highlight class="normal">GUI_TIMER_TIME<sp />GUI_X_GetTime(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="105"><highlight class="normal">{</highlight></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp />GUI_TIMER_TIME<sp />time;</highlight></codeline>
<codeline lineno="107"><highlight class="normal" /></codeline>
<codeline lineno="108"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(GUI_OS<sp />==<sp />0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />time<sp />=<sp />emwin_time_ms;</highlight></codeline>
<codeline lineno="110"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_time_t<sp />rtos_time;</highlight></codeline>
<codeline lineno="112"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />cy_rtos_get_time(&amp;rtos_time);</highlight></codeline>
<codeline lineno="113"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="114"><highlight class="normal" /></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />time<sp />=<sp />(GUI_TIMER_TIME)rtos_time;</highlight></codeline>
<codeline lineno="116"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="117"><highlight class="normal" /></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />time;</highlight></codeline>
<codeline lineno="119"><highlight class="normal">}</highlight></codeline>
<codeline lineno="120"><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_Delay(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />ms)</highlight></codeline>
<codeline lineno="122"><highlight class="normal">{</highlight></codeline>
<codeline lineno="123"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(GUI_OS<sp />==<sp />0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />tEnd<sp />=<sp />emwin_time_ms<sp />+<sp />ms;</highlight></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />((tEnd<sp />-<sp />emwin_time_ms)<sp />&gt;<sp />0)</highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="129"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />cy_rtos_delay_milliseconds((cy_time_t)ms);</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="132"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="133"><highlight class="normal">}</highlight></codeline>
<codeline lineno="134"><highlight class="normal" /></codeline>
<codeline lineno="135"><highlight class="normal" /><highlight class="comment">/*********************************************************************</highlight></codeline>
<codeline lineno="136"><highlight class="comment">*</highlight></codeline>
<codeline lineno="137"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp />GUI_X_Init()</highlight></codeline>
<codeline lineno="138"><highlight class="comment">*</highlight></codeline>
<codeline lineno="139"><highlight class="comment">*<sp />Note:</highlight></codeline>
<codeline lineno="140"><highlight class="comment">*<sp /><sp /><sp />This<sp />routine<sp />is<sp />called<sp />from<sp />GUI_Init()<sp />in<sp />any<sp />case<sp />whether<sp />there</highlight></codeline>
<codeline lineno="141"><highlight class="comment">*<sp /><sp /><sp />is<sp />an<sp />RTOS<sp />or<sp />not.<sp />You<sp />can<sp />use<sp />it<sp />for<sp />additional<sp />initializations</highlight></codeline>
<codeline lineno="142"><highlight class="comment">*<sp /><sp /><sp />needed.</highlight></codeline>
<codeline lineno="143"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="144"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_Init(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="145"><highlight class="normal">{</highlight></codeline>
<codeline lineno="146"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(GUI_OS<sp />==<sp />0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="147"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />emwin_timer_init();</highlight></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_syspm_register_callback(&amp;emwin_timer_syspm_callback_data);</highlight></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="150"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="151"><highlight class="normal">}</highlight></codeline>
<codeline lineno="152"><highlight class="normal" /></codeline>
<codeline lineno="153"><highlight class="normal" /><highlight class="comment">/*********************************************************************</highlight></codeline>
<codeline lineno="154"><highlight class="comment">*</highlight></codeline>
<codeline lineno="155"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI_X_ExecIdle</highlight></codeline>
<codeline lineno="156"><highlight class="comment">*</highlight></codeline>
<codeline lineno="157"><highlight class="comment">*<sp />Note:</highlight></codeline>
<codeline lineno="158"><highlight class="comment">*<sp /><sp />Called<sp />if<sp />WM<sp />is<sp />in<sp />idle<sp />state</highlight></codeline>
<codeline lineno="159"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="160"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_ExecIdle(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="161"><highlight class="normal">{</highlight></codeline>
<codeline lineno="162"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(GUI_OS<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />cy_rtos_delay_milliseconds((cy_time_t)1u);</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="165"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="166"><highlight class="normal">}</highlight></codeline>
<codeline lineno="167"><highlight class="normal" /></codeline>
<codeline lineno="168"><highlight class="normal" /><highlight class="comment">/*********************************************************************</highlight></codeline>
<codeline lineno="169"><highlight class="comment">*</highlight></codeline>
<codeline lineno="170"><highlight class="comment">*<sp /><sp /><sp /><sp /><sp /><sp />Logging:<sp />OS<sp />dependent</highlight></codeline>
<codeline lineno="171"><highlight class="comment">*</highlight></codeline>
<codeline lineno="172"><highlight class="comment">*<sp />Note:</highlight></codeline>
<codeline lineno="173"><highlight class="comment">*<sp /><sp /><sp />Logging<sp />is<sp />used<sp />in<sp />higher<sp />debug<sp />levels<sp />only.<sp />The<sp />typical<sp />target</highlight></codeline>
<codeline lineno="174"><highlight class="comment">*<sp /><sp /><sp />build<sp />does<sp />not<sp />use<sp />logging<sp />and<sp />does<sp />therefor<sp />not<sp />require<sp />any<sp />of</highlight></codeline>
<codeline lineno="175"><highlight class="comment">*<sp /><sp /><sp />the<sp />logging<sp />routines<sp />below.<sp />For<sp />a<sp />release<sp />build<sp />without<sp />logging</highlight></codeline>
<codeline lineno="176"><highlight class="comment">*<sp /><sp /><sp />the<sp />routines<sp />below<sp />may<sp />be<sp />eliminated<sp />to<sp />save<sp />some<sp />space.</highlight></codeline>
<codeline lineno="177"><highlight class="comment">*<sp /><sp /><sp />(If<sp />the<sp />linker<sp />is<sp />not<sp />function<sp />aware<sp />and<sp />eliminates<sp />unreferenced</highlight></codeline>
<codeline lineno="178"><highlight class="comment">*<sp /><sp /><sp />functions<sp />automatically)</highlight></codeline>
<codeline lineno="179"><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="180"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_Log<sp /><sp /><sp /><sp /><sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*s)<sp />{<sp />GUI_USE_PARA(s);<sp />}</highlight></codeline>
<codeline lineno="181"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_Warn<sp /><sp /><sp /><sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*s)<sp />{<sp />GUI_USE_PARA(s);<sp />}</highlight></codeline>
<codeline lineno="182"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_ErrorOut(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*s)<sp />{<sp />GUI_USE_PARA(s);<sp />}</highlight></codeline>
<codeline lineno="183"><highlight class="normal" /></codeline>
<codeline lineno="184"><highlight class="normal" /></codeline>
<codeline lineno="185"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(GUI_OS<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline lineno="186"><highlight class="normal" /></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*********************************************************************</highlight></codeline>
<codeline lineno="188"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="189"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp /><sp /><sp />Multitasking:</highlight></codeline>
<codeline lineno="190"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="191"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI_X_InitOS()</highlight></codeline>
<codeline lineno="192"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI_X_GetTaskId()</highlight></codeline>
<codeline lineno="193"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI_X_Lock()</highlight></codeline>
<codeline lineno="194"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />GUI_X_Unlock()</highlight></codeline>
<codeline lineno="195"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="196"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />Note:</highlight></codeline>
<codeline lineno="197"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp />The<sp />following<sp />routines<sp />are<sp />required<sp />only<sp />if<sp />emWin<sp />is<sp />used<sp />in<sp />a</highlight></codeline>
<codeline lineno="198"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp />true<sp />multitask<sp />environment,<sp />which<sp />means<sp />you<sp />have<sp />more<sp />than<sp />one</highlight></codeline>
<codeline lineno="199"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp />thread<sp />using<sp />the<sp />emWin<sp />API.</highlight></codeline>
<codeline lineno="200"><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="201"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_InitOS(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="203"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />cy_rtos_init_mutex(&amp;emwin_mutex);</highlight></codeline>
<codeline lineno="204"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="205"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="206"><highlight class="normal" /></codeline>
<codeline lineno="207"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_Unlock(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="208"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="209"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />cy_rtos_set_mutex(&amp;emwin_mutex);</highlight></codeline>
<codeline lineno="210"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="211"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="212"><highlight class="normal" /></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />GUI_X_Lock(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="214"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="215"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />cy_rtos_get_mutex(&amp;emwin_mutex,<sp />CY_RTOS_NEVER_TIMEOUT);</highlight></codeline>
<codeline lineno="216"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="218"><highlight class="normal" /></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp />U32<sp />GUI_X_GetTaskId(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="220"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_thread_t<sp />current_thread;</highlight></codeline>
<codeline lineno="222"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp /><sp />cy_rtos_get_thread_handle(&amp;current_thread);</highlight></codeline>
<codeline lineno="223"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(CY_RSLT_SUCCESS<sp />==<sp />status);</highlight></codeline>
<codeline lineno="224"><highlight class="normal" /></codeline>
<codeline lineno="225"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(U32)current_thread;</highlight></codeline>
<codeline lineno="226"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="227"><highlight class="normal" /></codeline>
<codeline lineno="228"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="229"><highlight class="normal" /></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*********************************************************************</highlight></codeline>
<codeline lineno="231"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="232"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Setup<sp />emWin<sp />timer</highlight></codeline>
<codeline lineno="233"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="234"><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />emwin_timer_init(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="236"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cyhal_timer_cfg_t<sp />emwin_timer_cfg<sp />=<sp />\</highlight></codeline>
<codeline lineno="238"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="239"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.compare_value<sp />=<sp />EMWIN_TIMER_PERIOD,<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Timer<sp />compare<sp />value,<sp />not<sp />used<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.period<sp />=<sp />EMWIN_TIMER_PERIOD,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Defines<sp />the<sp />timer<sp />period<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="241"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.direction<sp />=<sp />CYHAL_TIMER_DIR_UP,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Timer<sp />counts<sp />up<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.is_compare<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Don't<sp />use<sp />compare<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.is_continuous<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Run<sp />timer<sp />indefinitely<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="244"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.value<sp />=<sp />0u<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initial<sp />value<sp />of<sp />counter<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="245"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="246"><highlight class="normal" /></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />timer<sp />object.<sp />Does<sp />not<sp />use<sp />pin<sp />output<sp />('pin'<sp />is<sp />NC)<sp />and</highlight></codeline>
<codeline lineno="248"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />does<sp />not<sp />use<sp />a<sp />pre-configured<sp />clock<sp />source<sp />('clk'<sp />is<sp />NULL).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_rslt_t<sp />status<sp />=<sp />cyhal_timer_init(&amp;emwin_timer,<sp />(cyhal_gpio_t)<sp />NC,<sp />NULL);</highlight></codeline>
<codeline lineno="250"><highlight class="normal" /></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_RSLT_SUCCESS<sp />==<sp />status)</highlight></codeline>
<codeline lineno="252"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />timer<sp />period<sp />and<sp />operation<sp />mode<sp />such<sp />as<sp />count<sp />direction,</highlight></codeline>
<codeline lineno="254"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />duration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="255"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp />cyhal_timer_configure(&amp;emwin_timer,<sp />&amp;emwin_timer_cfg);</highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="257"><highlight class="normal" /></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_RSLT_SUCCESS<sp />==<sp />status)</highlight></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />frequency<sp />of<sp />timer's<sp />clock<sp />source<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="261"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp />cyhal_timer_set_frequency(&amp;emwin_timer,<sp />EMWIN_TIMER_CLOCK_HZ);</highlight></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="263"><highlight class="normal" /></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_RSLT_SUCCESS<sp />==<sp />status)</highlight></codeline>
<codeline lineno="265"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="266"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Assign<sp />the<sp />ISR<sp />to<sp />execute<sp />on<sp />timer<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="267"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_timer_register_callback(&amp;emwin_timer,<sp />isr_emwin_timer,<sp />NULL);</highlight></codeline>
<codeline lineno="268"><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />event<sp />on<sp />which<sp />timer<sp />interrupt<sp />occurs<sp />and<sp />enable<sp />it<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_timer_enable_event(&amp;emwin_timer,<sp />CYHAL_TIMER_IRQ_CAPTURE_COMPARE,</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />EMWIN_TIMER_IRQ_PRIORITY,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="272"><highlight class="normal" /></codeline>
<codeline lineno="273"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />the<sp />timer<sp />with<sp />the<sp />configured<sp />settings<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="274"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp />cyhal_timer_start(&amp;emwin_timer);</highlight></codeline>
<codeline lineno="275"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="276"><highlight class="normal" /></codeline>
<codeline lineno="277"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />status;</highlight></codeline>
<codeline lineno="278"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="279"><highlight class="normal" /></codeline>
<codeline lineno="280"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />emwin_timer_syspm_callback(cyhal_syspm_callback_state_t<sp />state,<sp />cyhal_syspm_callback_mode_t<sp />mode,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />callback_arg)</highlight></codeline>
<codeline lineno="281"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="282"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal">(mode)</highlight></codeline>
<codeline lineno="283"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="284"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />CYHAL_SYSPM_CHECK_READY:</highlight></codeline>
<codeline lineno="285"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_timer_free(&amp;emwin_timer);</highlight></codeline>
<codeline lineno="286"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="287"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="288"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />CYHAL_SYSPM_CHECK_FAIL:</highlight></codeline>
<codeline lineno="289"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />CYHAL_SYSPM_AFTER_TRANSITION:</highlight></codeline>
<codeline lineno="290"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />emwin_timer_init();</highlight></codeline>
<codeline lineno="291"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="292"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />CYHAL_SYSPM_BEFORE_TRANSITION:</highlight></codeline>
<codeline lineno="293"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">default</highlight><highlight class="normal">:</highlight></codeline>
<codeline lineno="294"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="295"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="296"><highlight class="normal" /></codeline>
<codeline lineno="297"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="298"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="299"><highlight class="normal" /></codeline>
<codeline lineno="300"><highlight class="normal" /></codeline>
<codeline lineno="301"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="302"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />Function<sp />Name:<sp />isr_timer</highlight></codeline>
<codeline lineno="303"><highlight class="comment"><sp /><sp /><sp /><sp />********************************************************************************</highlight></codeline>
<codeline lineno="304"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />Summary:</highlight></codeline>
<codeline lineno="305"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />This<sp />is<sp />the<sp />interrupt<sp />handler<sp />function<sp />for<sp />the<sp />timer<sp />interrupt.</highlight></codeline>
<codeline lineno="306"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="307"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />Parameters:</highlight></codeline>
<codeline lineno="308"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />void</highlight></codeline>
<codeline lineno="309"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="310"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />Return:</highlight></codeline>
<codeline lineno="311"><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />void</highlight></codeline>
<codeline lineno="312"><highlight class="comment"><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="313"><highlight class="comment"><sp /><sp /><sp /><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="314"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />isr_emwin_timer(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg,<sp />cyhal_timer_event_t<sp />event)</highlight></codeline>
<codeline lineno="315"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="316"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<sp />callback_arg;</highlight></codeline>
<codeline lineno="317"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<sp />event;</highlight></codeline>
<codeline lineno="318"><highlight class="normal" /></codeline>
<codeline lineno="319"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />emwin_time_ms++;</highlight></codeline>
<codeline lineno="320"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="321"><highlight class="normal" /></codeline>
<codeline lineno="322"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="323"><highlight class="normal" /></codeline>
<codeline lineno="324"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="325"><highlight class="normal">}</highlight></codeline>
<codeline lineno="326"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="327"><highlight class="normal" /></codeline>
<codeline lineno="328"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />EMWIN_ENABLED<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="329"><highlight class="normal" /></codeline>
<codeline lineno="330"><highlight class="normal" /></codeline>
<codeline lineno="331"><highlight class="normal" /><highlight class="comment">/***************************<sp />End<sp />of<sp />file<sp />****************************/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_ST7789V/display-tft-st7789v/configs/emwin/GUI_X.c" />
  </compounddef>
</doxygen>